Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJob.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJob.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJob.cs	(revision 6033)
@@ -24,9 +24,8 @@
 using System.Drawing;
 using System.Linq;
-using HeuristicLab.Clients.Hive.Jobs;
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
+using HeuristicLab.Hive;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.PluginInfrastructure;
@@ -36,6 +35,6 @@
   [Item("Hive Job", "Represents a hive job.")]
   [StorableClass]
-  public class HiveJob : NamedItem, IItemTree {
-    private static object locker = new object();
+  public class HiveJob : NamedItem, IItemTree<HiveJob> {
+    protected static object locker = new object();
 
     public override Image ItemImage {
@@ -56,5 +55,5 @@
     }
 
-    private Job job;
+    protected Job job;
     public Job Job {
       get { return job; }
@@ -70,16 +69,16 @@
 
     [Storable]
-    private OptimizerJob optimizerJob;
-    public OptimizerJob OptimizerJob {
-      get { return optimizerJob; }
+    protected ItemJob jobItem;
+    public ItemJob JobItem {
+      get { return jobItem; }
       internal set {
-        if (optimizerJob != null && syncJobsWithOptimizers) {
+        if (jobItem != null && syncJobsWithOptimizers) {
           this.childHiveJobs.Clear();
         }
-        if (optimizerJob != value) {
-          DergisterOptimizerEvents();
-          optimizerJob = value;
-          RegisterOptimizerEvents();
-          OnOptimizerJobChanged();
+        if (jobItem != value) {
+          DergisterJobItemsEvents();
+          jobItem = value;
+          RegisterJobItemEvents();
+          OnJobItemChanged();
         }
       }
@@ -87,12 +86,13 @@
 
     [Storable]
-    private ItemList<HiveJob> childHiveJobs;
-    public ReadOnlyItemList<HiveJob> ChildHiveJobs {
+    protected ItemList<HiveJob> childHiveJobs;
+    public virtual ReadOnlyItemList<HiveJob> ChildHiveJobs {
       get { return childHiveJobs.AsReadOnly(); }
     }
 
     [Storable]
-    private bool syncJobsWithOptimizers = true;
-
+    protected bool syncJobsWithOptimizers = true;
+
+    #region Constructors and Cloning
     public HiveJob() {
       this.Job = new Job() {
@@ -106,14 +106,9 @@
     }
 
-    public HiveJob(OptimizerJob optimizerJob, bool autoCreateChildHiveJobs)
+    public HiveJob(ItemJob jobItem, bool autoCreateChildHiveJobs)
       : this() {
       this.syncJobsWithOptimizers = autoCreateChildHiveJobs;
-      this.OptimizerJob = optimizerJob;
+      this.JobItem = jobItem;
       this.syncJobsWithOptimizers = true;
-    }
-
-    public HiveJob(IOptimizer optimizer)
-      : this() {
-      this.OptimizerJob = new OptimizerJob(optimizer);
     }
 
@@ -122,8 +117,8 @@
       this.Job = job;
       try {
-        this.OptimizerJob = PersistenceUtil.Deserialize<OptimizerJob>(jobData.Data);
+        this.JobItem = PersistenceUtil.Deserialize<ItemJob>(jobData.Data);
       }
       catch {
-        this.OptimizerJob = null;
+        this.JobItem = null;
       }
       this.childHiveJobs = new ItemList<HiveJob>();
@@ -135,82 +130,34 @@
       : base(original, cloner) {
       this.Job = cloner.Clone(original.job);
-      this.OptimizerJob = cloner.Clone(original.OptimizerJob);
+      this.JobItem = cloner.Clone(original.JobItem);
+      this.childHiveJobs = cloner.Clone(original.childHiveJobs);
+      this.syncJobsWithOptimizers = original.syncJobsWithOptimizers;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
       return new HiveJob(this, cloner);
     }
-
-    /// <summary>
-    /// if this.Optimizer is an experiment
-    ///   Uses the child-optimizers of this.HiveJob and creates HiveJob-childs
-    /// if this.Optimizer is a batchrun
-    ///   Creates a number of child-jobs according to repetitions
-    /// </summary>
-    private void UpdateChildHiveJobs() {
-      if (Job != null && syncJobsWithOptimizers) {
-        if (!OptimizerJob.ComputeInParallel) {
-          this.childHiveJobs.Clear();
-        } else {
-          if (OptimizerJob.Optimizer is Optimization.Experiment) {
-            Optimization.Experiment experiment = (Optimization.Experiment)OptimizerJob.Optimizer;
-            foreach (IOptimizer childOpt in experiment.Optimizers) {
-              this.childHiveJobs.Add(new HiveJob(childOpt));
-            }
-          } else if (OptimizerJob.Optimizer is Optimization.BatchRun) {
-            Optimization.BatchRun batchRun = OptimizerJob.OptimizerAsBatchRun;
-            if (batchRun.Optimizer != null) {
-              while (this.childHiveJobs.Count < batchRun.Repetitions) {
-                this.childHiveJobs.Add(new HiveJob(batchRun.Optimizer));
-              }
-              while (this.childHiveJobs.Count > batchRun.Repetitions) {
-                this.childHiveJobs.Remove(this.childHiveJobs.Last());
-              }
-            }
-          }
-        }
-      }
-    }
-
-    private void RegisterOptimizerEvents() {
-      if (OptimizerJob != null) {
-        if (OptimizerJob.Optimizer is Optimization.Experiment) {
-          Optimization.Experiment experiment = OptimizerJob.OptimizerAsExperiment;
-          experiment.Optimizers.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_ItemsAdded);
-          experiment.Optimizers.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_ItemsReplaced);
-          experiment.Optimizers.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_ItemsRemoved);
-          experiment.Optimizers.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_CollectionReset);
-        } else if (OptimizerJob.Optimizer is Optimization.BatchRun) {
-          Optimization.BatchRun batchRun = OptimizerJob.OptimizerAsBatchRun;
-          batchRun.RepetitionsChanged += new EventHandler(batchRun_RepetitionsChanged);
-          batchRun.OptimizerChanged += new EventHandler(batchRun_OptimizerChanged);
-        }
-        OptimizerJob.ComputeInParallelChanged += new EventHandler(OptimizerJob_ComputeInParallelChanged);
-        OptimizerJob.ToStringChanged += new EventHandler(OptimizerJob_ToStringChanged);
-      }
-    }
-    private void DergisterOptimizerEvents() {
-      if (OptimizerJob != null) {
-        if (OptimizerJob.Optimizer is Optimization.Experiment) {
-          Optimization.Experiment experiment = OptimizerJob.OptimizerAsExperiment;
-          experiment.Optimizers.ItemsAdded -= new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_ItemsAdded);
-          experiment.Optimizers.ItemsReplaced -= new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_ItemsReplaced);
-          experiment.Optimizers.ItemsRemoved -= new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_ItemsRemoved);
-          experiment.Optimizers.CollectionReset -= new CollectionItemsChangedEventHandler<IndexedItem<IOptimizer>>(Optimizers_CollectionReset);
-        } else if (OptimizerJob.Optimizer is Optimization.BatchRun) {
-          Optimization.BatchRun batchRun = OptimizerJob.OptimizerAsBatchRun;
-          batchRun.RepetitionsChanged -= new EventHandler(batchRun_RepetitionsChanged);
-          batchRun.OptimizerChanged -= new EventHandler(batchRun_OptimizerChanged);
-        }
-        OptimizerJob.ComputeInParallelChanged -= new EventHandler(OptimizerJob_ComputeInParallelChanged);
-        OptimizerJob.ToStringChanged -= new EventHandler(OptimizerJob_ToStringChanged);
-      }
-    }
-
-    private void RegisterChildHiveJobEvents() {
+    #endregion
+
+    protected virtual void UpdateChildHiveJobs() { }
+
+    protected virtual void RegisterJobItemEvents() {
+      if (JobItem != null) {
+        JobItem.ComputeInParallelChanged += new EventHandler(JobItem_ComputeInParallelChanged);
+        JobItem.ToStringChanged += new EventHandler(JobItem_ToStringChanged);
+      }
+    }
+    protected virtual void DergisterJobItemsEvents() {
+      if (JobItem != null) {
+        JobItem.ComputeInParallelChanged -= new EventHandler(JobItem_ComputeInParallelChanged);
+        JobItem.ToStringChanged -= new EventHandler(JobItem_ToStringChanged);
+      }
+    }
+
+    protected virtual void RegisterChildHiveJobEvents() {
       this.childHiveJobs.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<HiveJob>>(OnItemsAdded);
       this.childHiveJobs.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<HiveJob>>(OnItemsRemoved);
       this.childHiveJobs.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<HiveJob>>(OnCollectionReset);
     }
-    private void DeregisterChildHiveJobEvents() {
+    protected virtual void DeregisterChildHiveJobEvents() {
       this.childHiveJobs.ItemsAdded -= new CollectionItemsChangedEventHandler<IndexedItem<HiveJob>>(OnItemsAdded);
       this.childHiveJobs.ItemsRemoved -= new CollectionItemsChangedEventHandler<IndexedItem<HiveJob>>(OnItemsRemoved);
@@ -218,214 +165,21 @@
     }
 
-    private void batchRun_OptimizerChanged(object sender, EventArgs e) {
-      if (syncJobsWithOptimizers) {
-        UpdateChildHiveJobs();
-      }
-    }
-
-    private void batchRun_RepetitionsChanged(object sender, EventArgs e) {
-      if (syncJobsWithOptimizers) {
-        UpdateChildHiveJobs();
-      }
-    }
-
-    private void OptimizerJob_ToStringChanged(object sender, EventArgs e) {
+    protected virtual void JobItem_ToStringChanged(object sender, EventArgs e) {
       this.OnToStringChanged();
     }
-
-    private void Optimizers_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOptimizer>> e) {
-      if (syncJobsWithOptimizers && this.OptimizerJob.ComputeInParallel) {
-        foreach (var item in e.Items) {
-          if (GetChildByOptimizer(item.Value) == null && item.Value.Name != "Placeholder") {
-            this.childHiveJobs.Add(new HiveJob(item.Value));
-          }
-        }
-      }
-    }
-    private void Optimizers_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOptimizer>> e) {
-      if (syncJobsWithOptimizers && this.OptimizerJob.ComputeInParallel) {
-        foreach (var item in e.OldItems) {
-          this.childHiveJobs.Remove(this.GetChildByOptimizer(item.Value));
-        }
-        foreach (var item in e.Items) {
-          if (GetChildByOptimizer(item.Value) == null && item.Value.Name != "Placeholder") {
-            this.childHiveJobs.Add(new HiveJob(item.Value));
-          }
-        }
-      }
-    }
-    private void Optimizers_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOptimizer>> e) {
-      if (syncJobsWithOptimizers && this.OptimizerJob.ComputeInParallel) {
-        foreach (var item in e.Items) {
-          this.childHiveJobs.Remove(this.GetChildByOptimizer(item.Value));
-        }
-      }
-    }
-    private void Optimizers_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<IOptimizer>> e) {
-      if (syncJobsWithOptimizers && this.OptimizerJob.ComputeInParallel) {
-        foreach (var item in e.Items) {
-          this.childHiveJobs.Remove(this.GetChildByOptimizer(item.Value));
-        }
-      }
-    }
-
-    private void OptimizerJob_ComputeInParallelChanged(object sender, EventArgs e) {
-      if (OptimizerJob != null && syncJobsWithOptimizers) {
+    
+    protected virtual void JobItem_ComputeInParallelChanged(object sender, EventArgs e) {
+      if (JobItem != null && syncJobsWithOptimizers) {
         this.UpdateChildHiveJobs();
       }
     }
 
-    public void AddChildHiveJob(HiveJob hiveJob) {
+    public virtual void AddChildHiveJob(HiveJob hiveJob) {
       this.childHiveJobs.Add(hiveJob);
-      syncJobsWithOptimizers = false;
-      if (this.OptimizerJob != null && hiveJob.OptimizerJob != null) {
-        // if job is in state Paused, it has to preserve its ResultCollection, which is cleared when a optimizer is added to an experiment
-        OptimizerJob optimizerJobClone = null;
-        if (hiveJob.Job.State == JobState.Paused) {
-          optimizerJobClone = (OptimizerJob)hiveJob.OptimizerJob.Clone();
-        }
-
-        if (this.OptimizerJob.Optimizer is Optimization.Experiment) {
-          if (!this.OptimizerJob.OptimizerAsExperiment.Optimizers.Contains(hiveJob.OptimizerJob.Optimizer)) {
-            UpdateOptimizerInExperiment(this.OptimizerJob.OptimizerAsExperiment, hiveJob.OptimizerJob);
-          }
-        } else if (this.OptimizerJob.Optimizer is Optimization.BatchRun) {
-          UpdateOptimizerInBatchRun(this.OptimizerJob.OptimizerAsBatchRun, hiveJob.OptimizerJob);
-        }
-
-        if (hiveJob.Job.State == JobState.Paused) {
-          hiveJob.OptimizerJob = optimizerJobClone;
-        }
-      }
-      syncJobsWithOptimizers = true;
-    }
-
-    /// <summary>
-    /// if this.Optimizer is Experiment
-    ///   replace the child-optimizer in the experiment
-    /// if this.Optimizer is BatchRun
-    ///   add the runs from the optimizerJob to the batchrun and replace the Optimizer
-    /// </summary>
-    public void UpdateChildOptimizer(OptimizerJob optimizerJob, Guid childJobId) {
-      syncJobsWithOptimizers = false; // don't sync with optimizers during this method
-      bool childIsFinishedOptimizerDownloaded = false;
-
-      if (this.OptimizerJob != null && this.OptimizerJob.Optimizer != null) {
-        if (this.OptimizerJob.Optimizer is Optimization.Experiment) {
-          UpdateOptimizerInExperiment(this.OptimizerJob.OptimizerAsExperiment, optimizerJob);
-          childIsFinishedOptimizerDownloaded = true;
-        } else if (this.OptimizerJob.Optimizer is Optimization.BatchRun) {
-          UpdateOptimizerInBatchRun(this.OptimizerJob.OptimizerAsBatchRun, optimizerJob);
-          if (this.OptimizerJob.OptimizerAsBatchRun.Repetitions == this.OptimizerJob.Optimizer.Runs.Count) {
-            childIsFinishedOptimizerDownloaded = true;
-          }
-        } else {
-          childIsFinishedOptimizerDownloaded = optimizerJob.Optimizer.ExecutionState == ExecutionState.Stopped;
-        }
-      }
-
-      HiveJob child = this.ChildHiveJobs.Single(j => j.Job.Id == childJobId);
-      if (!optimizerJob.ComputeInParallel) {
-        child.syncJobsWithOptimizers = false;
-        child.OptimizerJob = optimizerJob;
-        child.syncJobsWithOptimizers = true;
-      }
-      if (childIsFinishedOptimizerDownloaded) {
-        //child.IsFinishedOptimizerDownloaded = true; // todo: clean up with childIsFinishedOptimizerDownloaded
-      }
-      syncJobsWithOptimizers = true;
-    }
-
-    /// <summary>
-    /// Adds the runs from the optimizerJob to the batchrun and replaces the Optimizer 
-    /// Sideeffect: the optimizerJob.Optimizer will be prepared (scopes are deleted and executionstate will be reset)
-    /// </summary>
-    private void UpdateOptimizerInBatchRun(BatchRun batchRun, OptimizerJob optimizerJob) {
-      if (batchRun.Optimizer == null) {
-        batchRun.Optimizer = (IOptimizer)optimizerJob.Optimizer; // only set the first optimizer as Optimizer. if every time the Optimizer would be set, the runs would be cleared each time
-      }
-      foreach (IRun run in optimizerJob.Optimizer.Runs) {
-        if (!batchRun.Runs.Contains(run)) {
-          run.Name = GetNewRunName(run, batchRun.Runs);
-          batchRun.Runs.Add(run);
-        }
-      }
-    }
-
-    /// <summary>
-    /// Parses the run numbers out of runs and renames the run to the next number
-    /// </summary>
-    private static string GetNewRunName(IRun run, RunCollection runs) {
-      int idx = run.Name.IndexOf("Run ") + 4;
-
-      if (idx == -1 || runs.Count == 0)
-        return run.Name;
-
-      int maxRunNumber = int.MinValue;
-      foreach (IRun r in runs) {
-        int number = GetRunNumber(r.Name);
-        maxRunNumber = Math.Max(maxRunNumber, number);
-      }
-
-      return run.Name.Substring(0, idx) + (maxRunNumber + 1).ToString();
-    }
-
-    /// <summary>
-    /// Parses the number of a Run out of its name. Example "Genetic Algorithm Run 3" -> 3
-    /// </summary>
-    private static int GetRunNumber(string runName) {
-      int idx = runName.IndexOf("Run ") + 4;
-      if (idx == -1) {
-        return 0;
-      } else {
-        return int.Parse(runName.Substring(idx, runName.Length - idx));
-      }
-    }
-
-    /// <summary>
-    /// replace the child-optimizer in the experiment
-    /// Sideeffect: the optimizerJob.Optimizer will be prepared (scopes are deleted and executionstate will be reset)
-    /// </summary>
-    private void UpdateOptimizerInExperiment(Optimization.Experiment experiment, OptimizerJob optimizerJob) {
-      if (optimizerJob.IndexInParentOptimizerList < 0)
-        throw new IndexOutOfRangeException("IndexInParentOptimizerList must be equal or greater than zero! The Job is invalid and the optimizer-tree cannot be reassembled.");
-
-      while (experiment.Optimizers.Count < optimizerJob.IndexInParentOptimizerList) {
-        experiment.Optimizers.Add(new UserDefinedAlgorithm("Placeholder")); // add dummy-entries to Optimizers so that its possible to insert the optimizerJob at the correct position
-      }
-      if (experiment.Optimizers.Count < optimizerJob.IndexInParentOptimizerList + 1) {
-        experiment.Optimizers.Add(optimizerJob.Optimizer);
-      } else {
-        // if ComputeInParallel==true, don't replace the optimizer (except it is still a Placeholder)
-        // this is because Jobs with ComputeInParallel get submitted to hive with their child-optimizers deleted
-        if (!optimizerJob.ComputeInParallel || experiment.Optimizers[optimizerJob.IndexInParentOptimizerList].Name == "Placeholder") {
-          experiment.Optimizers[optimizerJob.IndexInParentOptimizerList] = optimizerJob.Optimizer;
-        }
-      }
-    }
-
-    /// <summary>
-    /// Sets the IndexInParentOptimizerList property of the OptimizerJob
-    /// according to the position in the OptimizerList of the parentHiveJob.Job
-    /// Recursively updates all the child-jobs as well
-    /// </summary>
-    internal void SetIndexInParentOptimizerList(HiveJob parentHiveJob) {
-      if (parentHiveJob != null) {
-        if (parentHiveJob.OptimizerJob.Optimizer is Optimization.Experiment) {
-          this.OptimizerJob.IndexInParentOptimizerList = parentHiveJob.OptimizerJob.OptimizerAsExperiment.Optimizers.IndexOf(this.OptimizerJob.Optimizer);
-        } else if (parentHiveJob.OptimizerJob.Optimizer is Optimization.BatchRun) {
-          this.OptimizerJob.IndexInParentOptimizerList = 0;
-        } else {
-          throw new NotSupportedException("Only Experiment and BatchRuns are supported");
-        }
-      }
-      foreach (HiveJob child in childHiveJobs) {
-        child.SetIndexInParentOptimizerList(this);
-      }
     }
 
     public override string ToString() {
-      if (optimizerJob != null) {
-        return optimizerJob.ToString();
+      if (jobItem != null) {
+        return jobItem.ToString();
       } else {
         return base.ToString();
@@ -433,5 +187,5 @@
     }
 
-    public void UpdateFromLightweightJob(LightweightJob lightweightJob) {
+    public virtual void UpdateFromLightweightJob(LightweightJob lightweightJob) {
       if (lightweightJob != null) {
         job.Id = lightweightJob.Id;
@@ -455,41 +209,12 @@
     ///   if true the Child-Optimizers will not be serialized (if the job contains an Experiment)
     /// </param>
-    public JobData GetAsJobData(bool withoutChildOptimizers, out List<IPluginDescription> plugins) {
-      plugins = new List<IPluginDescription>();
-      if (this.optimizerJob == null || this.optimizerJob.Optimizer == null)
-        return null;
-
-      IEnumerable<Type> usedTypes;
-      byte[] jobByteArray;
-      if (withoutChildOptimizers && this.OptimizerJob.Optimizer is Optimization.Experiment) {
-        OptimizerJob clonedJob = (OptimizerJob)this.OptimizerJob.Clone(); // use a cloned job, so that the childHiveJob don't get confused
-        clonedJob.OptimizerAsExperiment.Optimizers.Clear();
-        jobByteArray = PersistenceUtil.Serialize(clonedJob, out usedTypes);
-      } else if (withoutChildOptimizers && this.OptimizerJob.Optimizer is Optimization.BatchRun) {
-        OptimizerJob clonedJob = (OptimizerJob)this.OptimizerJob.Clone();
-        clonedJob.OptimizerAsBatchRun.Optimizer = null;
-        jobByteArray = PersistenceUtil.Serialize(clonedJob, out usedTypes);
-      } else if (this.OptimizerJob.Optimizer is IAlgorithm) {
-        ((IAlgorithm)this.OptimizerJob.Optimizer).StoreAlgorithmInEachRun = false; // avoid storing the algorithm in runs to reduce size
-        jobByteArray = PersistenceUtil.Serialize(this.OptimizerJob, out usedTypes);
-      } else {
-        jobByteArray = PersistenceUtil.Serialize(this.OptimizerJob, out usedTypes);
-      }
-
-      JobData jobData = new JobData() {
-        JobId = job.Id,
-        Data = jobByteArray
-      };
-
-      PluginUtil.CollectDeclaringPlugins(plugins, usedTypes);
-
-      return jobData;
-    }
-
+    public virtual JobData GetAsJobData(bool withoutChildOptimizers, out List<IPluginDescription> plugins) {
+      plugins = null;
+      return null;
+    }
 
     #region Events
     public event EventHandler JobChanged;
     private void OnJobChanged() {
-      LogMessage("JobChanged");
       EventHandler handler = JobChanged;
       if (handler != null) handler(this, EventArgs.Empty);
@@ -498,13 +223,12 @@
     public event EventHandler JobStateChanged;
     private void OnJobStateChanged() {
-      LogMessage("JobStateChanged (State: " + this.Job.State + ", ExecutionTime: " + this.Job.ExecutionTime.ToString() + ")");
       EventHandler handler = JobStateChanged;
       if (handler != null) handler(this, EventArgs.Empty);
     }
 
-    public event EventHandler OptimizerJobChanged;
-    private void OnOptimizerJobChanged() {
-      OptimizerJob_ComputeInParallelChanged(this, EventArgs.Empty);
-      var handler = OptimizerJobChanged;
+    public event EventHandler JobItemChanged;
+    private void OnJobItemChanged() {
+      JobItem_ComputeInParallelChanged(this, EventArgs.Empty);
+      var handler = JobItemChanged;
       if (handler != null) handler(this, EventArgs.Empty);
     }
@@ -516,18 +240,10 @@
     }
     #endregion
-
-    public void LogMessage(string message) {
-      lock (locker) {
-        if (optimizerJob != null) {
-          optimizerJob.Log.LogMessage(message);
-        }
-      }
-    }
-
+    
     /// <summary>
     /// Returns a list of HiveJobs including this and all its child-jobs recursively
     /// </summary>
     public IEnumerable<HiveJob> GetAllHiveJobs() {
-      List<HiveJob> jobs = new List<HiveJob>();
+      var jobs = new List<HiveJob>();
       jobs.Add(this);
       foreach (HiveJob child in this.ChildHiveJobs) {
@@ -544,22 +260,4 @@
         if (result != null)
           return result;
-      }
-      return null;
-    }
-
-
-    public HiveJob GetChildByOptimizerJob(OptimizerJob optimizerJob) {
-      foreach (var child in ChildHiveJobs) {
-        if (child.OptimizerJob == optimizerJob)
-          return child;
-      }
-      return null;
-    }
-
-
-    public HiveJob GetChildByOptimizer(IOptimizer optimizer) {
-      foreach (var child in ChildHiveJobs) {
-        if (child.OptimizerJob.Optimizer == optimizer)
-          return child;
       }
       return null;
@@ -582,5 +280,4 @@
     }
 
-
     public void RemoveByJobId(Guid jobId) {
       IEnumerable<HiveJob> jobs = ChildHiveJobs.Where(j => j.Job.Id == jobId).ToList(); // if Guid.Empty needs to be removed, there could be more than one with this jobId
@@ -593,5 +290,5 @@
     }
 
-    public IEnumerable<IItemTree> GetChildItems() {
+    public IEnumerable<IItemTree<HiveJob>> GetChildItems() {
       return this.childHiveJobs;
     }
@@ -599,5 +296,5 @@
     #region INotifyObservableCollectionItemsChanged<IItemTree> Members
 
-    public event CollectionItemsChangedEventHandler<IItemTree> CollectionReset;
+    public event CollectionItemsChangedEventHandler<IItemTree<HiveJob>> CollectionReset;
     private void OnCollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<HiveJob>> e) {
       var handler = CollectionReset;
@@ -605,5 +302,5 @@
     }
 
-    public event CollectionItemsChangedEventHandler<IItemTree> ItemsAdded;
+    public event CollectionItemsChangedEventHandler<IItemTree<HiveJob>> ItemsAdded;
     private void OnItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<HiveJob>> e) {
       var handler = ItemsAdded;
@@ -611,5 +308,5 @@
     }
 
-    public event CollectionItemsChangedEventHandler<IItemTree> ItemsRemoved;
+    public event CollectionItemsChangedEventHandler<IItemTree<HiveJob>> ItemsRemoved;
     private void OnItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<HiveJob>> e) {
       var handler = ItemsRemoved;
@@ -617,6 +314,6 @@
     }
 
-    private static CollectionItemsChangedEventArgs<IItemTree> ToCollectionItemsChangedEventArgs(CollectionItemsChangedEventArgs<IndexedItem<HiveJob>> e) {
-      return new CollectionItemsChangedEventArgs<IItemTree>(e.Items.Select(x => x.Value), e.OldItems == null ? null : e.OldItems.Select(x => x.Value));
+    private static CollectionItemsChangedEventArgs<IItemTree<HiveJob>> ToCollectionItemsChangedEventArgs(CollectionItemsChangedEventArgs<IndexedItem<HiveJob>> e) {
+      return new CollectionItemsChangedEventArgs<IItemTree<HiveJob>>(e.Items.Select(x => x.Value), e.OldItems == null ? null : e.OldItems.Select(x => x.Value));
     }
     #endregion
@@ -634,5 +331,5 @@
         JobData jobData = new JobData();
         jobData.JobId = this.job.Id;
-        jobData.Data = PersistenceUtil.Serialize(this.optimizerJob);
+        jobData.Data = PersistenceUtil.Serialize(this.jobItem);
         service.UpdateJobData(this.Job, jobData);
         service.RestartJob(this.job.Id);
@@ -641,4 +338,30 @@
       });
     }
+    
+    public ICollection<IItemTreeNodeAction<HiveJob>> Actions {
+      get {
+        return new List<IItemTreeNodeAction<HiveJob>>();
+      }
+    }
+  }
+
+  [Item("Hive Job", "Represents a hive job.")]
+  [StorableClass]
+  public class HiveJob<T> : HiveJob where T : ItemJob {
+
+    public new T JobItem {
+      get { return (T)base.JobItem; }
+      internal set { base.JobItem = value; }
+    }
+
+    #region Constructors and Cloning
+    public HiveJob() : base() { }
+    protected HiveJob(HiveJob original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new HiveJob<T>(this, cloner);
+    }
+    #endregion
   }
 }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobDownloader.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobDownloader.cs	(revision 6032)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/HiveJobDownloader.cs	(revision 6033)
@@ -4,4 +4,7 @@
 using System.Threading;
 using System.Threading.Tasks;
+using HeuristicLab.Clients.Hive.ExperimentManager;
+using HeuristicLab.Clients.Hive.Jobs;
+using HeuristicLab.Hive;
 
 namespace HeuristicLab.Clients.Hive {
@@ -86,5 +89,12 @@
         Job job = ServiceLocator.Instance.CallHiveService(s => s.GetJob(jobData.JobId));
         if (abort || job == null || jobData == null) return null;
-        HiveJob hiveJob = new HiveJob(job, jobData, false);
+
+        HiveJob hiveJob;
+        var itemJob = PersistenceUtil.Deserialize<ItemJob>(jobData.Data);
+        if (itemJob is OptimizerJob) {
+          hiveJob = new OptimizerHiveJob((OptimizerJob)itemJob);
+        } else {
+          hiveJob = new HiveJob(itemJob, true);
+        }
         jobData.Data = null; // reduce memory consumption.
         hiveJob.Job = job;
